#!/usr/bin/perl
# $Id: mkMake.pl,v 1.2 2006/02/04 13:15:56 maxhorn Exp $

$Q = $ARGV[0];
$N = $Q*$Q;

print "all:";
for ($b1 = 0; $b1 < $Q; ++$b1) {
	print " \\\n do-$b1";
}
print "\n";
print "\n";


for ($b1 = 0; $b1 < $Q; ++$b1) {
	print "do-$b1:";
	for ($c0 = 0; $c0 < $N; ++$c0) {
		print " \\\n results-$N/$b1-$c0.txt.bz2";
	}
	print "\n";
	print "\n";
}


for ($b1 = 0; $b1 < $Q; ++$b1) {
	for ($c0 = 0; $c0 < $N; ++$c0) {
		print "$b1-$c0: results-$N/$b1-$c0.txt.bz2\n";
		print "\n";
		print "results-$N/$b1-$c0.txt.bz2:\n";
		print "\t"."mkdir -p results-$N\n";
		print "\t"."time nice ./quads-$N $b1 $c0 | tee results-$N/$b1-$c0.txt\n";
		print "\t"."bzip2 -9 results-$N/$b1-$c0.txt\n";
		print "\n";
	}
}

print "\n";
print ".PHONY: all";
for ($b1 = 0; $b1 < $Q; ++$b1) {
	print " \\\n do-$b1";
	for ($c0 = 0; $c0 < $N; ++$c0) {
		print " \\\n $b1-$c0";
	}
}
print "\n";
print "\n";
